Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 6033)
@@ -74,5 +74,4 @@
       <HintPath>C:\Program Files\HeuristicLab 3.3\Calendar.DayView.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Clients.Hive.Views-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Collections-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Collections-3.3.dll</HintPath>
@@ -158,9 +157,15 @@
       <DependentUpon>UpdateControl.cs</DependentUpon>
     </Compile>
-    <Compile Include="ExperimentManager\HiveExperimentView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ExperimentManager\HiveExperimentView.Designer.cs">
-      <DependentUpon>HiveExperimentView.cs</DependentUpon>
+    <Compile Include="ExperimentManager\OptimizerHiveJobView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExperimentManager\OptimizerHiveJobView.designer.cs">
+      <DependentUpon>OptimizerHiveJobView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ExperimentManager\RefreshableHiveExperimentView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExperimentManager\RefreshableHiveExperimentView.Designer.cs">
+      <DependentUpon>RefreshableHiveExperimentView.cs</DependentUpon>
     </Compile>
     <Compile Include="ExperimentManager\HiveItemView.cs">
@@ -171,8 +176,16 @@
     </Compile>
     <Compile Include="ExperimentManager\StateLogListList.cs" />
-    <Compile Include="ExperimentManager\ItemTreeView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ExperimentManager\ItemTreeView.designer.cs">
+    <Compile Include="ExperimentManager\TreeView\NewExperimentTreeNodeAction.cs" />
+    <Compile Include="ExperimentManager\TreeView\DeleteJobTreeNodeAction.cs" />
+    <Compile Include="ExperimentManager\TreeView\HiveJobItemTreeView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExperimentManager\TreeView\HiveJobItemTreeView.Designer.cs">
+      <DependentUpon>HiveJobItemTreeView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="ExperimentManager\TreeView\ItemTreeView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="ExperimentManager\TreeView\ItemTreeView.designer.cs">
       <DependentUpon>ItemTreeView.cs</DependentUpon>
     </Compile>
@@ -283,8 +296,11 @@
       <DependentUpon>UpdateControl.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="ExperimentManager\HiveExperimentView.resx">
-      <DependentUpon>HiveExperimentView.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="ExperimentManager\ItemTreeView.resx">
+    <EmbeddedResource Include="ExperimentManager\OptimizerHiveJobView.resx">
+      <DependentUpon>OptimizerHiveJobView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ExperimentManager\RefreshableHiveExperimentView.resx">
+      <DependentUpon>RefreshableHiveExperimentView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="ExperimentManager\TreeView\ItemTreeView.resx">
       <DependentUpon>ItemTreeView.cs</DependentUpon>
     </EmbeddedResource>
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLabClientsHiveViewsPlugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLabClientsHiveViewsPlugin.cs.frame	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLabClientsHiveViewsPlugin.cs.frame	(revision 6033)
@@ -8,8 +8,20 @@
   [Plugin("HeuristicLab.Clients.Hive.Views", "3.4.0.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive.Views-3.4.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Clients.Hive", "3.4")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.DayView", "1.0")]
+  [PluginDependency("HeuristicLab.Hive", "3.4")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.DayView", "1.0")]
+  [PluginDependency("HeuristicLab.Services.Hive.Common", "3.4")]
+  [PluginDependency("HeuristicLab.Visualization.ChartControlsExtensions", "3.3")]
   public class HeuristicLabClientsHiveViewsPlugin : PluginBase {
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs	(revision 6033)
@@ -26,4 +26,5 @@
 using System.Linq;
 using System.Threading;
+using HeuristicLab.Clients.Hive.ExperimentManager;
 using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Common;
@@ -44,10 +45,15 @@
 
     #region Properties
-    private ItemCollection<HiveExperiment> hiveExperiments;
-    public ItemCollection<HiveExperiment> HiveExperiments {
+    private ItemCollection<RefreshableHiveExperiment> hiveExperiments;
+    public ItemCollection<RefreshableHiveExperiment> HiveExperiments {
       get { return hiveExperiments; }
-      set { hiveExperiments = value; }
-    }
-
+      set {
+        if (value != hiveExperiments) {
+          hiveExperiments = value;
+          OnHiveExperimentsChanged();
+        }
+      }
+    }
+    
     private List<Plugin> onlinePlugins;
     public List<Plugin> OnlinePlugins {
@@ -69,8 +75,12 @@
       OnRefreshing();
 
-      hiveExperiments = new HiveItemCollection<HiveExperiment>();
-
       try {
-        hiveExperiments.AddRange(ServiceLocator.Instance.CallHiveService<List<HiveExperiment>>(s => s.GetHiveExperiments()).OrderBy(x => x.Name));
+        hiveExperiments = new HiveItemCollection<RefreshableHiveExperiment>();
+        var he = ServiceLocator.Instance.CallHiveService<IEnumerable<HiveExperiment>>(s => s.GetHiveExperiments());
+        hiveExperiments.AddRange(he.Select(x => new RefreshableHiveExperiment(x)).OrderBy(x => x.HiveExperiment.Name));
+      }
+      catch {
+        hiveExperiments = null;
+        throw;
       }
       finally {
@@ -98,8 +108,9 @@
     public static void Store(IHiveItem item) {
       if (item.Id == Guid.Empty) {
-        if (item is HiveExperiment) {
-          ExperimentManagerClient.Instance.UploadExperiment((HiveExperiment)item);
+        if (item is RefreshableHiveExperiment) {
+          ExperimentManagerClient.Instance.UploadExperiment((RefreshableHiveExperiment)item);
         }
       } else {
+
         if (item is HiveExperiment)
           ServiceLocator.Instance.CallHiveService(s => s.UpdateHiveExperiment((HiveExperiment)item));
@@ -127,4 +138,6 @@
       if (item is HiveExperiment)
         ServiceLocator.Instance.CallHiveService(s => s.DeleteHiveExperiment(item.Id));
+      if (item is RefreshableHiveExperiment)
+        ServiceLocator.Instance.CallHiveService(s => s.DeleteHiveExperiment(item.Id));
       item.Id = Guid.Empty;
     }
@@ -142,13 +155,18 @@
       if (handler != null) handler(this, EventArgs.Empty);
     }
-    #endregion
-
-    public static void StartExperiment(Action<Exception> exceptionCallback, HiveExperiment hiveExperiment) {
+    public event EventHandler HiveExperimentsChanged;
+    private void OnHiveExperimentsChanged() {
+      var handler = HiveExperimentsChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+
+    public static void StartExperiment(Action<Exception> exceptionCallback, RefreshableHiveExperiment refreshableHiveExperiment) {
       ExperimentManagerClient.StoreAsync(
         new Action<Exception>((Exception ex) => {
-          hiveExperiment.ExecutionState = ExecutionState.Prepared;
+          refreshableHiveExperiment.HiveExperiment.ExecutionState = ExecutionState.Prepared;
           exceptionCallback(ex);
-        }), hiveExperiment);
-      hiveExperiment.ExecutionState = ExecutionState.Started;
+        }), refreshableHiveExperiment);
+      refreshableHiveExperiment.HiveExperiment.ExecutionState = ExecutionState.Started;
     }
 
@@ -174,10 +192,10 @@
 
     #region Upload Experiment
-    private void UploadExperiment(HiveExperiment hiveExperiment) {
+    private void UploadExperiment(RefreshableHiveExperiment optimizerHiveExperiment) {
       try {
-        hiveExperiment.Progress = new Progress("Connecting to server...");
-        hiveExperiment.IsProgressing = true;
+        optimizerHiveExperiment.HiveExperiment.Progress = new Progress("Connecting to server...");
+        optimizerHiveExperiment.HiveExperiment.IsProgressing = true;
         ServiceLocator.Instance.CallHiveService(service => {
-          IEnumerable<string> resourceNames = ToResourceNameList(hiveExperiment.ResourceNames);
+          IEnumerable<string> resourceNames = ToResourceNameList(optimizerHiveExperiment.HiveExperiment.ResourceNames);
           var resourceIds = new List<Guid>();
           foreach (var resourceName in resourceNames) {
@@ -189,17 +207,17 @@
           }
 
-          foreach (HiveJob hiveJob in hiveExperiment.HiveJobs) {
+          foreach (OptimizerHiveJob hiveJob in optimizerHiveExperiment.HiveExperiment.HiveJobs.OfType<OptimizerHiveJob>()) {
             hiveJob.SetIndexInParentOptimizerList(null);
           }
 
           // upload HiveExperiment
-          hiveExperiment.Progress.Status = "Uploading HiveExperiment...";
-          hiveExperiment.Id = service.AddHiveExperiment(hiveExperiment);
-
-          int totalJobCount = hiveExperiment.GetAllHiveJobs().Count();
+          optimizerHiveExperiment.HiveExperiment.Progress.Status = "Uploading HiveExperiment...";
+          optimizerHiveExperiment.HiveExperiment.Id = service.AddHiveExperiment(optimizerHiveExperiment.HiveExperiment);
+
+          int totalJobCount = optimizerHiveExperiment.HiveExperiment.GetAllHiveJobs().Count();
           int jobCount = 0;
 
           // upload plugins
-          hiveExperiment.Progress.Status = "Uploading plugins...";
+          optimizerHiveExperiment.HiveExperiment.Progress.Status = "Uploading plugins...";
           this.OnlinePlugins = service.GetPlugins();
           this.AlreadyUploadedPlugins = new List<Plugin>();
@@ -208,15 +226,15 @@
 
           // upload jobs
-          hiveExperiment.Progress.Status = "Uploading jobs...";
-
-          foreach (HiveJob hiveJob in hiveExperiment.HiveJobs) {
-            UploadJobWithChildren(hiveExperiment.Progress, service, hiveJob, null, resourceIds, ref jobCount, totalJobCount, configFilePlugin.Id, hiveExperiment.UseLocalPlugins, hiveExperiment.Id);
+          optimizerHiveExperiment.HiveExperiment.Progress.Status = "Uploading jobs...";
+
+          foreach (HiveJob hiveJob in optimizerHiveExperiment.HiveExperiment.HiveJobs) {
+            UploadJobWithChildren(optimizerHiveExperiment.HiveExperiment.Progress, service, hiveJob, null, resourceIds, ref jobCount, totalJobCount, configFilePlugin.Id, optimizerHiveExperiment.HiveExperiment.UseLocalPlugins, optimizerHiveExperiment.HiveExperiment.Id);
           }
 
-          if (hiveExperiment.RefreshAutomatically) hiveExperiment.StartResultPolling();
+          if (optimizerHiveExperiment.RefreshAutomatically) optimizerHiveExperiment.StartResultPolling();
         });
       }
       finally {
-        hiveExperiment.IsProgressing = false;
+        optimizerHiveExperiment.HiveExperiment.IsProgressing = false;
       }
     }
@@ -256,9 +274,9 @@
       List<IPluginDescription> plugins;
 
-      if (hiveJob.OptimizerJob.ComputeInParallel &&
-        (hiveJob.OptimizerJob.Optimizer is Optimization.Experiment || hiveJob.OptimizerJob.Optimizer is Optimization.BatchRun)) {
+      if (hiveJob.JobItem.ComputeInParallel &&
+        (hiveJob.JobItem.Item is Optimization.Experiment || hiveJob.JobItem.Item is Optimization.BatchRun)) {
         hiveJob.Job.IsParentJob = true;
         hiveJob.Job.FinishWhenChildJobsFinished = true;
-        hiveJob.OptimizerJob.CollectChildJobs = false; // don't collect child-jobs on slaves
+        hiveJob.JobItem.CollectChildJobs = false; // don't collect child-jobs on slaves
         jobData = hiveJob.GetAsJobData(true, out plugins);
       } else {
@@ -312,18 +330,10 @@
 
         hiveExperiment.HiveJobs = new ItemCollection<HiveJob>(allHiveJobs.Values.Where(x => !x.Job.ParentJobId.HasValue));
-        //hiveExperiment.HiveJobs = allHiveJobs[hiveExperiment.RootJobId];
 
         if (hiveExperiment.IsFinished()) {
-          //hiveExperiment.ExecutionTime = hiveExperiment.HiveJobs.Max(.Job.DateFinished.Value - hiveExperiment.HiveJobs.Job.DateCreated.Value;
-          //hiveExperiment.lastUpdateTime = hiveExperiment.HiveJob.Job.DateFinished.Value;
           hiveExperiment.ExecutionState = Core.ExecutionState.Stopped;
-          //OnStopped(); // todo: stop timer
         } else {
-          //hiveExperiment.ExecutionTime = hiveExperiment.HiveJobs.Job.DateCreated.HasValue ? DateTime.Now - hiveExperiment.HiveJobs.Job.DateCreated.Value : TimeSpan.Zero;
-          //hiveExperiment.lastUpdateTime = DateTime.Now;
           hiveExperiment.ExecutionState = Core.ExecutionState.Started;
-          //OnStarted(); // todo: start timer
-        }
-        hiveExperiment.UpdateTotalExecutionTime();
+        }
 
         // build child-job tree
@@ -331,9 +341,6 @@
           BuildHiveJobTree(hiveJob, allJobs, allHiveJobs);
         }
-        hiveExperiment.UpdateTotalExecutionTime();
-
-        if (hiveExperiment.ExecutionState != ExecutionState.Stopped) {
-          hiveExperiment.RefreshAutomatically = true;
-        }
+
+        hiveExperiment.OnLoaded();
       }
       finally {
